'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wrapper = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Wrapper'
})(['z-index:', ';transition:opacity 0.2s ease;align-items:center;position:fixed;display:flex;opacity:0;height:100%;left:-100%;width:100%;top:0;', ';'], function (props) {
  return props.theme.layers.modal;
}, function (props) {
  return props.active && '\n    left: 0;\n    opacity: 1;\n  ';
});

var Overlay = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Overlay'
})(['background-color:', ';position:absolute;opacity:0.3;height:100%;width:100%;left:0;top:0;backdrop-filter:blur(2px);'], function (props) {
  return props.theme.colors.black;
});

var Window = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Window'
})(['box-shadow:', ';border-radius:', ';background-color:', ';color:', ';width:', ';margin:0 auto;max-width:768px;padding:15px 20px 20px;position:relative;'], function (props) {
  return props.theme.boxShadow.light;
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.purple800;
}, function (props) {
  return props.width;
});

var Header = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Header'
})(['display:flex;justify-content:space-between;align-items:center;']);

var Title = _styledComponents2.default.span.withConfig({
  displayName: 'Dialog__Title'
})(['font-size:', ';font-weight:bold;'], function (props) {
  return props.theme.fontSizes.normal;
});

var ButtonClose = _styledComponents2.default.button.withConfig({
  displayName: 'Dialog__ButtonClose'
})(['border:0;background:transparent;cursor:pointer;margin-right:-5px;padding:5px;outline:0;&:hover{opacity:0.5;}']);

var Content = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Content'
})(['']);

var Actions = _styledComponents2.default.div.withConfig({
  displayName: 'Dialog__Actions'
})(['text-align:right;min-height:36px;button{margin-left:10px;}']);

/**
 * A dialog window
 * ```javascript
 * export defaut function DialogExample({closeHandler, actionClickHandler}) {
 *  return (
 *   <Dialog
 *      active={true}
 *      actions={['Submit', 'Cancel']}
 *      onClose={closeHandler}
 *      onActionClick={actionClickHandler}
 *    >
 *      <p>Here is some content that I would like to display</p>
 *    </Dialog>
 *  );
 * }
 * ```
 *
 * Example with pre-created action elements
 * ```javascript
 * export defaut function DialogExample({someHandlerFunc, otherHandlerFunc, handleClose}) {
 *     const Action1 = () => (
 *      <div onClick={someHandlerFunc}>Action1</div>
 *    );
 *     const Action2 = () => (
 *       <div onClick={otherHandlerFunc}>Action2</div>
 *    );
 *
 *    return (
 *      <Dialog
 *         active={true}
 *         actions={[Action1, Action2]}
 *         onClose={handleClose}
 *       >
 *         <p>This one has custom actions</p>
 *       </Dialog>
 *    );
 * }
 * ```
 */

var Dialog = function (_PureComponent) {
  _inherits(Dialog, _PureComponent);

  function Dialog() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Dialog);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call.apply(_ref, [this].concat(args))), _this), _this.onKeyDown = function (event) {
      if (_this.props.active && event.key === 'Escape') {
        _this.props.onClose(event);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Dialog, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.onKeyDown);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.onKeyDown);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          hideClose = _props.hideClose,
          title = _props.title,
          width = _props.width,
          actions = _props.actions,
          onActionClick = _props.onActionClick,
          onClose = _props.onClose,
          children = _props.children;


      return _react2.default.createElement(
        Wrapper,
        { active: active },
        _react2.default.createElement(Overlay, { onClick: onClose }),
        _react2.default.createElement(
          Window,
          { width: width },
          _react2.default.createElement(
            Header,
            null,
            _react2.default.createElement(
              Title,
              null,
              title
            ),
            !hideClose && _react2.default.createElement(
              ButtonClose,
              { text: '', onClick: onClose },
              _react2.default.createElement('i', { className: 'fa fa-close' })
            )
          ),
          _react2.default.createElement(
            Content,
            null,
            active && children
          ),
          !(0, _isEmpty3.default)(actions) && _react2.default.createElement(
            Actions,
            null,
            actions.map(function (Action, index) {
              if (_react2.default.isValidElement(Action)) {
                /* eslint-disable react/no-array-index-key */
                return _react2.default.cloneElement(Action, { key: index });
                /* eslint-enable react/no-array-index-key */
              }
              return _react2.default.createElement(_Button2.default, {
                key: Action,
                text: Action,
                onClick: function onClick() {
                  return onActionClick(Action);
                }
              });
            })
          )
        )
      );
    }
  }]);

  return Dialog;
}(_react.PureComponent);

Dialog.propTypes = {
  /**
   * Flag to show/hide the dialog
   */
  active: _propTypes2.default.bool.isRequired,
  /**
   * The title of the dialog
   */
  title: _propTypes2.default.string,
  /**
   * Width of the dialog window (CSS format)
   */
  width: _propTypes2.default.string,
  /**
   * An array of options that the user will be able to click.
   * Each item in the array will be rendered as a <Button /> in the dialog window.
   * Items can also be React elements.
   */
  actions: _propTypes2.default.array,
  /**
   * Callback that runs when an action is clicked by the user. If the actions
   * If the `actions` prop is an array of strings,
   * this callback will return the action that was clicked.
   */
  onActionClick: _propTypes2.default.func,
  /**
   * Callback that will be run when the modal is closed
   */
  onClose: _propTypes2.default.func,
  /**
   * Flag to hide the close icon in top right corner
   */
  hideClose: _propTypes2.default.bool
};

Dialog.defaultProps = {
  title: '',
  width: '75%',
  actions: [],
  onActionClick: _noop3.default,
  onClose: _noop3.default,
  hideClose: false
};

exports.default = Dialog;