'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _compact2 = require('lodash/compact');

var _compact3 = _interopRequireDefault(_compact2);

var _flatMap2 = require('lodash/flatMap');

var _flatMap3 = _interopRequireDefault(_flatMap2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _intersperse = require('intersperse');

var _intersperse2 = _interopRequireDefault(_intersperse);

var _polished = require('polished');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// For chunk = { text: 'abcd', matched: false } and match = 'bc', the output will be
// [{ text: 'a', matched: false }, { text: 'bc', matched: true }, { text: 'd', matched: false }].
var splitChunk = function splitChunk(chunk, match) {
  return (0, _compact3.default)((0, _intersperse2.default)(chunk.text.split(match), match)).map(function (text) {
    return {
      matched: text === match,
      text: text
    };
  });
};

// Splits the text into chunks by finding all occurences of all matches in the list.
var buildChunks = function buildChunks(_ref) {
  var text = _ref.text,
      matches = _ref.matches;

  var chunks = [{ text: text, matched: false }];
  matches.forEach(function (match) {
    chunks = (0, _flatMap3.default)(chunks,
    // Only unmatched chunks can be further split by other matches
    function (chunk) {
      return chunk.matched ? [chunk] : splitChunk(chunk, match);
    });
  });
  return chunks;
};

var MatchedChunk = _styledComponents2.default.span.withConfig({
  displayName: 'MatchedText__MatchedChunk'
})(['background-color:', ';border-radius:', ';'], function (props) {
  return (0, _polished.transparentize)(0.7, props.theme.colors.blue400);
}, function (props) {
  return props.theme.borderRadius.soft;
});

/**
 * Renders a block of text with matched sections highlighted
 *
 * `foo` is highlighted:
 *
 * ```
 * <MatchedText text="this that foo and bar" matches={['foo']} />
 * ```
 *
 */

var MatchedText = function (_React$PureComponent) {
  _inherits(MatchedText, _React$PureComponent);

  function MatchedText(props) {
    _classCallCheck(this, MatchedText);

    var _this = _possibleConstructorReturn(this, (MatchedText.__proto__ || Object.getPrototypeOf(MatchedText)).call(this, props));

    _this.state = {
      chunks: buildChunks(props)
    };
    return _this;
  }

  _createClass(MatchedText, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ chunks: buildChunks(nextProps) });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'span',
        { title: this.props.text },
        this.state.chunks.map(function (chunk, index) {
          if (chunk.matched) {
            /* eslint-disable react/no-array-index-key */
            return _react2.default.createElement(
              MatchedChunk,
              { key: index + ':' + chunk.text },
              chunk.text
            );
            /* eslint-enable react/no-array-index-key */
          }
          return chunk.text;
        })
      );
    }
  }]);

  return MatchedText;
}(_react2.default.PureComponent);

MatchedText.propTypes = {
  /**
   * The base text to display
   */
  text: _propTypes2.default.string.isRequired,
  /**
   * The chunks to be highlighted
   */
  matches: _propTypes2.default.arrayOf(_propTypes2.default.string)
};

MatchedText.defaultProps = {
  matches: []
};

exports.default = MatchedText;